ctypedef int size_t

cdef extern from "stdio.h":
     int printf(char* format, ...)

cdef extern from "Python.h":
     void* PyMem_Malloc(size_t n)
     void PyMem_Free(void *p)

     int PyCObject_Check(object p)
     object PyCObject_FromVoidPtr(void* cobj, void (*destr)(void *))
     object PyCObject_FromVoidPtrAndDesc(void* cobj, void* desc,
             void (*destr)(void *, void *))
     void* PyCObject_AsVoidPtr(object self)
     void* PyCObject_GetDesc(object self)

# These 2 functions are NOT ENOUGH for pointers. "char*" has two standard
# meanings. "AAA*" may be a pointer to AAA or an array of AAA. Etc.
cdef wrap_ptr(void* p, char* ctypename):
     return PyCObject_FromVoidPtrAndDesc(p, ctypename, NULL)

cdef void* extract_ptr(object PY):
     if PY is None:
         return NULL
     return PyCObject_AsVoidPtr(PY)

